package fr.username404.snowygui.gui.feature

import net.arikia.dev.drpc.DiscordRichPresence
import net.minecraft.client.Minecraft
import fr.username404.snowygui.gui.feature.ButtonInfo.Companion.Type
import net.arikia.dev.drpc.DiscordEventHandlers
import net.arikia.dev.drpc.DiscordRPC as discord_rpc

@ButtonInfo(Category.MISC, kind = Type.TOGGLE)
object DiscordRPC: ButtonImpl() {
    private val RPCHandlers: DiscordEventHandlers = DiscordEventHandlers.Builder().build()
    private val RichPresence: DiscordRichPresence.Builder = DiscordRichPresence
        .Builder("Playing Minecraft ${Minecraft.getInstance().game.version.name}")
        .setDetails("Launched with ${Minecraft.getInstance().launchedVersion}")
        .setBigImage("icon", "SnowyGUI")
    override fun execAction() {
        if (toggled) discord_rpc.discordUpdatePresence(RichPresence.build())
        else discord_rpc.discordClearPresence()
    }
    init {
        Runtime.getRuntime().addShutdownHook(Thread { discord_rpc.discordShutdown() })
        discord_rpc.discordInitialize("839058922102849538", RPCHandlers, true)
    }
}